ALTER TABLE WEB_RESOURCE
ADD PUBLISHED VARCHAR2(1 CHAR);

ALTER TABLE WEB_RESOURCE
ADD ID_HASH VARCHAR2(50 CHAR);

DROP VIEW V_WEB_RESOURCE;

CREATE OR REPLACE VIEW V_WEB_RESOURCE AS (
SELECT W.ID_WEB_RESOURCE, W.ID, W.NAME, W.URL, W.TYPE, W.ACT, W.DATE_CREATED, W.USER_CREATED, W.DATE_CHANGED, W.USER_CHANGED, W.PORTAL, W.PUBLISHED,
N.OPIS AS TYPE_OPIS, N.INTERNI_OPIS AS TYPE_INTERNI_OPIS
FROM WEB_RESOURCE W
LEFT OUTER JOIN NNWEBRESOURCE_TYPE N ON N.SIFRA = W.TYPE
);

UPDATE WEB_RESOURCE W
SET W.ID_HASH = ORA_HASH (W.ID_WEB_RESOURCE || SYSTIMESTAMP || SYS_GUID ())
WHERE W.ID_HASH IS NULL;

UPDATE WEB_RESOURCE W
SET W.ID_HASH = (CASE WHEN LENGTH(W.ID_HASH) < 50 THEN LPAD(W.ID_HASH,50,ABS(DBMS_RANDOM.RANDOM)) ELSE TO_CHAR(W.ID_HASH) END)
WHERE LENGTH(W.ID_HASH) < 50;

CREATE OR REPLACE
TRIGGER WEB_RESOURCE_ID_HASH_TRG
BEFORE INSERT OR UPDATE
ON WEB_RESOURCE
REFERENCING NEW AS NEW OLD AS OLD
FOR EACH ROW
DECLARE
   ID_HASH VARCHAR2(50);;
BEGIN
	IF (:NEW.ID_HASH IS NULL) THEN
      SELECT ORA_HASH (:NEW.ID_WEB_RESOURCE || SYSTIMESTAMP || SYS_GUID ()) INTO ID_HASH FROM DUAL;;
      :NEW.ID_HASH := (CASE WHEN LENGTH(ID_HASH) < 50 THEN LPAD(ID_HASH,50,ABS(DBMS_RANDOM.RANDOM)) ELSE TO_CHAR(ID_HASH) END);;
	END IF;;
END;;
;

insert into verzije_baza
(id, dt_vpis, verzija, ver_nr, opis) values (2230, SYSDATE, '5.5', 2150, 'WebResource idHash')
;
